package aQute.maven;

import java.util.*;

class HtmlPageIterator implements Iterator<HtmlPage> {
	final HtmlPage		page;
	int					element;
	Iterator<HtmlPage>	next;

	public HtmlPageIterator(HtmlPage page, int i) {
		this.page = page;
		this.element = i;
	}

	@Override
	public boolean hasNext() {
		try {
			while (true) {
				if (next != null && next.hasNext())
					return true;

				if (element >= page.links.size())
					return false;

				String link = page.links.get(element++);
				HtmlPage child = page.getPage(link);
				if (child == null)
					return false;

				if (child.isPom()) {
					// wow, the child is the version
					// dir so we are the artifact dir.
					// so our children or what we
					// return
					List<HtmlPage> versions = new ArrayList<HtmlPage>();
					versions.add(child);
					for (int i = element + 1; i < page.links.size(); i++) {
						versions.add(page.getPage(page.links.get(i)));
					}
					next = versions.iterator();
					return next.hasNext();
				}
				next = child.iterator();
			}
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public HtmlPage next() {
		return next.next();
	}

	@Override
	public void remove() {}

}
